unit MyTimer;

// MyTimer.pas by Daniel Marschall
// www.viathinksoft.de

interface

uses
  Windows;

type
  TMyTimer = class(TObject)
  private
    FTimerFreq: int64;
    FTimerStart: int64;
    FTimerStop: int64;
    FCounterTime: int64;
    FRunning: boolean;
    function GetTime(): int64;
    function GetRunning(): boolean;
    function GetCurrentDifference(): int64;
  public
    function StopAndZero(): int64;
    procedure StartTimer();
    procedure StopTimer();
    property Time: int64 read GetTime;
    property Running: boolean read GetRunning;
  end;

implementation

// Vorlage:
// http://entwickler-forum.de/archive/index.php/t-14659.html

function TMyTimer.GetCurrentDifference(): int64;
begin
  QueryPerformanceCounter(FTimerStop);
  result := (FTimerStop-FTimerStart) * 1000 div FTimerFreq;
end;

function TMyTimer.GetRunning(): boolean;
begin
  result := FRunning;
end;

function TMyTimer.GetTime(): int64;
begin
  result := FCounterTime;

  if {F}Running then
  begin
    result := result + GetCurrentDifference();
  end;
end;

procedure TMyTimer.StartTimer();
begin
  QueryPerformanceFrequency(FTimerFreq);
  QueryPerformanceCounter(FTimerStart);
  FRunning := true;
end;

procedure TMyTimer.StopTimer();
begin
  FRunning := false;
  FCounterTime := FCounterTime + GetCurrentDifference();
end;

function TMyTimer.StopAndZero(): int64;
begin
  if {F}Running then StopTimer();
  FCounterTime := 0;
  result := {Get}Time;
end;

end.
