<?php

// ViaThinkSoft HWSNGen 2.1

// Translated from HWSNGen.pas

function IsValidHWID($hwid) {
	define('INSIDE_INTEGRITY_SALT', ')$"(KDASF2904uJHfF');
	define('VER_PREFIX', 'VHID21');
	define('SEP', '-');

	function ValidLowerCaseHexString($str) {
		for ($i = 0; $i < strlen($str); $i++) {
			$ch = substr($str, $i, 1);

			if (($ch != 'a') && ($ch != 'b') && ($ch != 'c') && ($ch != 'd') &&
			    ($ch != 'e') && ($ch != 'f') && ($ch != '0') && ($ch != '1') &&
			    ($ch != '2') && ($ch != '3') && ($ch != '4') && ($ch != '5') &&
			    ($ch != '6') && ($ch != '7') && ($ch != '8') && ($ch != '9')) return false;
		}
		return true;
	}

	function CreateIntegrityHash($stringToVerify) {
		$result = md5(INSIDE_INTEGRITY_SALT . $stringToVerify);
		$result = substr($result, 0, 16);
		return $result;
	}

	// Step 1: Length OK?

	if (strlen($hwid) != strlen(VER_PREFIX)+1+32+1+16) return false;

	// Step 2: Is the prefix OK?

	if (substr($hwid, 0, strlen(VER_PREFIX)) != VER_PREFIX) return false;

	if (substr($hwid, strlen(VER_PREFIX), 1) != SEP) return false;

	// Extract MD5 parts

	$identification = substr($hwid, strlen(VER_PREFIX)+1, 32);

	if (substr($hwid, strlen(VER_PREFIX)+1+32, 1) != SEP) return false;

	$verify = substr($hwid, strlen(VER_PREFIX)+1+32+1, 16);

	// Step 3: Only valid characters?

	if (!ValidLowerCaseHexString($identification)) return false;

	// Step 4: Integrity match?

	if ($verify != CreateIntegrityHash($identification)) return false;

	// Step 5: Integrity MD5 OK? (Actually unneccessary because of Step 4)

	if (!ValidLowerCaseHexString($verify)) return false;

	return true;
}

?>